Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/tesselation.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -2055,93 +2212,100 @@
 
   // 1. searching topmost point with respect to each axis
-  for (int i=0;i<NDIM;i++) { // each axis
-    LC->n[i] = LC->N[i]-1; // current axis is topmost cell
-    for (LC->n[(i+1)%NDIM]=0;LC->n[(i+1)%NDIM]<LC->N[(i+1)%NDIM];LC->n[(i+1)%NDIM]++)
-      for (LC->n[(i+2)%NDIM]=0;LC->n[(i+2)%NDIM]<LC->N[(i+2)%NDIM];LC->n[(i+2)%NDIM]++) {
-        const LinkedNodes *List = LC->GetCurrentCell();
+  for (int i = 0; i < NDIM; i++) { // each axis
+    LC->n[i] = LC->N[i] - 1; // current axis is topmost cell
+    for (LC->n[(i + 1) % NDIM] = 0; LC->n[(i + 1) % NDIM] < LC->N[(i + 1) % NDIM]; LC->n[(i + 1) % NDIM]++)
+      for (LC->n[(i + 2) % NDIM] = 0; LC->n[(i + 2) % NDIM] < LC->N[(i + 2) % NDIM]; LC->n[(i + 2) % NDIM]++) {
+        const LinkedCell::LinkedNodes *List = LC->GetCurrentCell();
         //Log() << Verbose(1) << "Current cell is " << LC->n[0] << ", " << LC->n[1] << ", " << LC->n[2] << " with No. " << LC->index << "." << endl;
         if (List != NULL) {
-          for (LinkedNodes::const_iterator Runner = List->begin();Runner != List->end();Runner++) {
-            if ((*Runner)->node->x[i] > maxCoordinate[i]) {
-              Log() << Verbose(1) << "New maximal for axis " << i << " node is " << *(*Runner) << " at " << *(*Runner)->node << "." << endl;
-              maxCoordinate[i] = (*Runner)->node->x[i];
+          for (LinkedCell::LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
+            if ((*Runner)->node->at(i) > maxCoordinate[i]) {
+              DoLog(1) && (Log() << Verbose(1) << "New maximal for axis " << i << " node is " << *(*Runner) << " at " << *(*Runner)->node << "." << endl);
+              maxCoordinate[i] = (*Runner)->node->at(i);
               MaxPoint[i] = (*Runner);
             }
           }
         } else {
-          eLog() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << " is invalid!" << endl;
+          DoeLog(1) && (eLog() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << " is invalid!" << endl);
         }
       }
   }
 
-  Log() << Verbose(1) << "Found maximum coordinates: ";
-  for (int i=0;i<NDIM;i++)
-    Log() << Verbose(0) << i << ": " << *MaxPoint[i] << "\t";
-  Log() << Verbose(0) << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Found maximum coordinates: ");
+  for (int i = 0; i < NDIM; i++)
+    DoLog(0) && (Log() << Verbose(0) << i << ": " << *MaxPoint[i] << "\t");
+  DoLog(0) && (Log() << Verbose(0) << endl);
 
   BTS = NULL;
-  for (int k=0;k<NDIM;k++) {
+  for (int k = 0; k < NDIM; k++) {
     NormalVector.Zero();
-    NormalVector.x[k] = 1.;
-    BaseLine.endpoints[0] = new BoundaryPointSet(MaxPoint[k]);
-    Log() << Verbose(0) << "Coordinates of start node at " << *BaseLine.endpoints[0]->node << "." << endl;
+    NormalVector[k] = 1.;
+    BaseLine = new BoundaryLineSet();
+    BaseLine->endpoints[0] = new BoundaryPointSet(MaxPoint[k]);
+    DoLog(0) && (Log() << Verbose(0) << "Coordinates of start node at " << *BaseLine->endpoints[0]->node << "." << endl);
 
     double ShortestAngle;
     ShortestAngle = 999999.; // This will contain the angle, which will be always positive (when looking for second point), when looking for third point this will be the quadrant.
 
-    FindSecondPointForTesselation(BaseLine.endpoints[0]->node, NormalVector, Temporary, &ShortestAngle, RADIUS, LC); // we give same point as next candidate as its bonds are looked into in find_second_...
-    if (Temporary == NULL)  // have we found a second point?
+    Temporary = NULL;
+    FindSecondPointForTesselation(BaseLine->endpoints[0]->node, NormalVector, Temporary, &ShortestAngle, RADIUS, LC); // we give same point as next candidate as its bonds are looked into in find_second_...
+    if (Temporary == NULL) {
+      // have we found a second point?
+      delete BaseLine;
       continue;
-    BaseLine.endpoints[1] = new BoundaryPointSet(Temporary);
+    }
+    BaseLine->endpoints[1] = new BoundaryPointSet(Temporary);
 
     // construct center of circle
-    CircleCenter.CopyVector(BaseLine.endpoints[0]->node->node);
-    CircleCenter.AddVector(BaseLine.endpoints[1]->node->node);
-    CircleCenter.Scale(0.5);
+    CircleCenter = 0.5 * ((*BaseLine->endpoints[0]->node->node) + (*BaseLine->endpoints[1]->node->node));
 
     // construct normal vector of circle
-    CirclePlaneNormal.CopyVector(BaseLine.endpoints[0]->node->node);
-    CirclePlaneNormal.SubtractVector(BaseLine.endpoints[1]->node->node);
+    CirclePlaneNormal = (*BaseLine->endpoints[0]->node->node) - (*BaseLine->endpoints[1]->node->node);
 
     double radius = CirclePlaneNormal.NormSquared();
-    double CircleRadius = sqrt(RADIUS*RADIUS - radius/4.);
-
-    NormalVector.ProjectOntoPlane(&CirclePlaneNormal);
+    double CircleRadius = sqrt(RADIUS * RADIUS - radius / 4.);
+
+    NormalVector.ProjectOntoPlane(CirclePlaneNormal);
     NormalVector.Normalize();
-    ShortestAngle = 2.*M_PI; // This will indicate the quadrant.
-
-    SphereCenter.CopyVector(&NormalVector);
-    SphereCenter.Scale(CircleRadius);
-    SphereCenter.AddVector(&CircleCenter);
+    ShortestAngle = 2. * M_PI; // This will indicate the quadrant.
+
+    SphereCenter = (CircleRadius * NormalVector) +  CircleCenter;
     // Now, NormalVector and SphereCenter are two orthonormalized vectors in the plane defined by CirclePlaneNormal (not normalized)
 
     // look in one direction of baseline for initial candidate
-    SearchDirection.MakeNormalVector(&CirclePlaneNormal, &NormalVector);  // whether we look "left" first or "right" first is not important ...
+    SearchDirection = Plane(CirclePlaneNormal, NormalVector,0).getNormal();  // whether we look "left" first or "right" first is not important ...
 
     // adding point 1 and point 2 and add the line between them
-    Log() << Verbose(0) << "Coordinates of start node at " << *BaseLine.endpoints[0]->node << "." << endl;
-    Log() << Verbose(0) << "Found second point is at " << *BaseLine.endpoints[1]->node << ".\n";
+    DoLog(0) && (Log() << Verbose(0) << "Coordinates of start node at " << *BaseLine->endpoints[0]->node << "." << endl);
+    DoLog(0) && (Log() << Verbose(0) << "Found second point is at " << *BaseLine->endpoints[1]->node << ".\n");
 
     //Log() << Verbose(1) << "INFO: OldSphereCenter is at " << helper << ".\n";
-    CandidateForTesselation OptCandidates(&BaseLine);
+    CandidateForTesselation OptCandidates(BaseLine);
     FindThirdPointForTesselation(NormalVector, SearchDirection, SphereCenter, OptCandidates, NULL, RADIUS, LC);
-    Log() << Verbose(0) << "List of third Points is:" << endl;
+    DoLog(0) && (Log() << Verbose(0) << "List of third Points is:" << endl);
     for (TesselPointList::iterator it = OptCandidates.pointlist.begin(); it != OptCandidates.pointlist.end(); it++) {
-        Log() << Verbose(0) << " " << *(*it) << endl;
-    }
-
-    BTS = NULL;
-    AddCandidateTriangle(OptCandidates);
-//    delete(BaseLine.endpoints[0]);
-//    delete(BaseLine.endpoints[1]);
-
-    if (BTS != NULL) // we have created one starting triangle
+      DoLog(0) && (Log() << Verbose(0) << " " << *(*it) << endl);
+    }
+    if (!OptCandidates.pointlist.empty()) {
+      BTS = NULL;
+      AddCandidatePolygon(OptCandidates, RADIUS, LC);
+    } else {
+      delete BaseLine;
+      continue;
+    }
+
+    if (BTS != NULL) { // we have created one starting triangle
+      delete BaseLine;
       break;
-    else {
+    } else {
       // remove all candidates from the list and then the list itself
       OptCandidates.pointlist.clear();
     }
-  }
-};
+    delete BaseLine;
+  }
+
+  return (BTS != NULL);
+}
+;
 
 /** Checks for a given baseline and a third point candidate whether baselines of the found triangle don't have even better candidates.
@@ -2214,5 +2378,5 @@
 //            if (fabs(OldSphereCenter.ScalarProduct(&SearchDirection)) > HULLEPSILON) {
 //              // rotated the wrong way!
-//              eLog() << Verbose(1) << "SearchDirection and RelativeOldSphereCenter are still not orthogonal!" << endl;
+//              DoeLog(1) && (eLog()<< Verbose(1) << "SearchDirection and RelativeOldSphereCenter are still not orthogonal!" << endl);
 //            }
 //
@@ -2271,5 +2435,5 @@
 //          }
 //        } else {
-//          eLog() << Verbose(2) << "Baseline is connected to two triangles already?" << endl;
+//          DoeLog(2) && (eLog()<< Verbose(2) << "Baseline is connected to two triangles already?" << endl);
 //        }
 //      } else {
@@ -2278,5 +2442,5 @@
 //    }
 //  } else {
-//    eLog() << Verbose(1) << "Could not find the TesselPoint " << *ThirdNode << "." << endl;
+//    DoeLog(1) && (eLog()<< Verbose(1) << "Could not find the TesselPoint " << *ThirdNode << "." << endl);
 //  }
 //
@@ -2292,9 +2456,7 @@
  * @param *LC LinkedCell structure with neighbouring points
  */
-bool Tesselation::FindNextSuitableTriangle(CandidateForTesselation &CandidateLine, BoundaryTriangleSet &T, const double& RADIUS, const LinkedCell *LC)
-{
-	Info FunctionInfo(__func__);
-  bool result = true;
-
+bool Tesselation::FindNextSuitableTriangle(CandidateForTesselation &CandidateLine, const BoundaryTriangleSet &T, const double& RADIUS, const LinkedCell *LC)
+{
+  Info FunctionInfo(__func__);
   Vector CircleCenter;
   Vector CirclePlaneNormal;
@@ -2302,161 +2464,107 @@
   Vector SearchDirection;
   Vector helper;
-  TesselPoint *ThirdNode = NULL;
+  BoundaryPointSet *ThirdPoint = NULL;
   LineMap::iterator testline;
   double radius, CircleRadius;
 
-  for (int i=0;i<3;i++)
-    if ((T.endpoints[i]->node != CandidateLine.BaseLine->endpoints[0]->node) && (T.endpoints[i]->node != CandidateLine.BaseLine->endpoints[1]->node)) {
-      ThirdNode = T.endpoints[i]->node;
+  for (int i = 0; i < 3; i++)
+    if ((T.endpoints[i] != CandidateLine.BaseLine->endpoints[0]) && (T.endpoints[i] != CandidateLine.BaseLine->endpoints[1])) {
+      ThirdPoint = T.endpoints[i];
       break;
     }
-  Log() << Verbose(0) << "Current baseline is " << *CandidateLine.BaseLine << " with ThirdNode " << *ThirdNode << " of triangle " << T << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Current baseline is " << *CandidateLine.BaseLine << " with ThirdPoint " << *ThirdPoint << " of triangle " << T << "." << endl);
+
+  CandidateLine.T = &T;
 
   // construct center of circle
-  CircleCenter.CopyVector(CandidateLine.BaseLine->endpoints[0]->node->node);
-  CircleCenter.AddVector(CandidateLine.BaseLine->endpoints[1]->node->node);
-  CircleCenter.Scale(0.5);
+  CircleCenter = 0.5 * ((*CandidateLine.BaseLine->endpoints[0]->node->node) +
+                        (*CandidateLine.BaseLine->endpoints[1]->node->node));
 
   // construct normal vector of circle
-  CirclePlaneNormal.CopyVector(CandidateLine.BaseLine->endpoints[0]->node->node);
-  CirclePlaneNormal.SubtractVector(CandidateLine.BaseLine->endpoints[1]->node->node);
+  CirclePlaneNormal = (*CandidateLine.BaseLine->endpoints[0]->node->node) -
+                      (*CandidateLine.BaseLine->endpoints[1]->node->node);
 
   // calculate squared radius of circle
-  radius = CirclePlaneNormal.ScalarProduct(&CirclePlaneNormal);
-  if (radius/4. < RADIUS*RADIUS) {
+  radius = CirclePlaneNormal.ScalarProduct(CirclePlaneNormal);
+  if (radius / 4. < RADIUS * RADIUS) {
     // construct relative sphere center with now known CircleCenter
-    RelativeSphereCenter.CopyVector(&T.SphereCenter);
-    RelativeSphereCenter.SubtractVector(&CircleCenter);
-
-    CircleRadius = RADIUS*RADIUS - radius/4.;
+    RelativeSphereCenter = T.SphereCenter - CircleCenter;
+
+    CircleRadius = RADIUS * RADIUS - radius / 4.;
     CirclePlaneNormal.Normalize();
-    Log() << Verbose(1) << "INFO: CircleCenter is at " << CircleCenter << ", CirclePlaneNormal is " << CirclePlaneNormal << " with circle radius " << sqrt(CircleRadius) << "." << endl;
-
-    Log() << Verbose(1) << "INFO: OldSphereCenter is at " << T.SphereCenter << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "INFO: CircleCenter is at " << CircleCenter << ", CirclePlaneNormal is " << CirclePlaneNormal << " with circle radius " << sqrt(CircleRadius) << "." << endl);
+
+    DoLog(1) && (Log() << Verbose(1) << "INFO: OldSphereCenter is at " << T.SphereCenter << "." << endl);
 
     // construct SearchDirection and an "outward pointer"
-    SearchDirection.MakeNormalVector(&RelativeSphereCenter, &CirclePlaneNormal);
-    helper.CopyVector(&CircleCenter);
-    helper.SubtractVector(ThirdNode->node);
-    if (helper.ScalarProduct(&SearchDirection) < -HULLEPSILON)// ohoh, SearchDirection points inwards!
+    SearchDirection = Plane(RelativeSphereCenter, CirclePlaneNormal,0).getNormal();
+    helper = CircleCenter - (*ThirdPoint->node->node);
+    if (helper.ScalarProduct(SearchDirection) < -HULLEPSILON)// ohoh, SearchDirection points inwards!
       SearchDirection.Scale(-1.);
-    Log() << Verbose(1) << "INFO: SearchDirection is " << SearchDirection << "." << endl;
-    if (fabs(RelativeSphereCenter.ScalarProduct(&SearchDirection)) > HULLEPSILON) {
+    DoLog(1) && (Log() << Verbose(1) << "INFO: SearchDirection is " << SearchDirection << "." << endl);
+    if (fabs(RelativeSphereCenter.ScalarProduct(SearchDirection)) > HULLEPSILON) {
       // rotated the wrong way!
-      eLog() << Verbose(1) << "SearchDirection and RelativeOldSphereCenter are still not orthogonal!" << endl;
+      DoeLog(1) && (eLog() << Verbose(1) << "SearchDirection and RelativeOldSphereCenter are still not orthogonal!" << endl);
     }
 
     // add third point
-    FindThirdPointForTesselation(T.NormalVector, SearchDirection, T.SphereCenter, CandidateLine, ThirdNode, RADIUS, LC);
+    FindThirdPointForTesselation(T.NormalVector, SearchDirection, T.SphereCenter, CandidateLine, ThirdPoint, RADIUS, LC);
 
   } else {
-    Log() << Verbose(0) << "Circumcircle for base line " << *CandidateLine.BaseLine << " and base triangle " << T << " is too big!" << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Circumcircle for base line " << *CandidateLine.BaseLine << " and base triangle " << T << " is too big!" << endl);
   }
 
   if (CandidateLine.pointlist.empty()) {
-    eLog() << Verbose(2) << "Could not find a suitable candidate." << endl;
+    DoeLog(2) && (eLog() << Verbose(2) << "Could not find a suitable candidate." << endl);
     return false;
   }
-  Log() << Verbose(0) << "Third Points are: " << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Third Points are: " << endl);
   for (TesselPointList::iterator it = CandidateLine.pointlist.begin(); it != CandidateLine.pointlist.end(); ++it) {
-    Log() << Verbose(0) << " " << *(*it) << endl;
+    DoLog(0) && (Log() << Verbose(0) << " " << *(*it) << endl);
   }
 
   return true;
-
-//  BoundaryLineSet *BaseRay = CandidateLine.BaseLine;
-//  for (CandidateList::iterator it = OptCandidates->begin(); it != OptCandidates->end(); ++it) {
-//    Log() << Verbose(0) << "Third point candidate is " << *(*it)->point
-//    << " with circumsphere's center at " << (*it)->OptCenter << "." << endl;
-//    Log() << Verbose(0) << "Baseline is " << *BaseRay << endl;
-//
-//    // check whether all edges of the new triangle still have space for one more triangle (i.e. TriangleCount <2)
-//    TesselPoint *PointCandidates[3];
-//    PointCandidates[0] = (*it)->point;
-//    PointCandidates[1] = BaseRay->endpoints[0]->node;
-//    PointCandidates[2] = BaseRay->endpoints[1]->node;
-//    int existentTrianglesCount = CheckPresenceOfTriangle(PointCandidates);
-//
-//    BTS = NULL;
-//    // check for present edges and whether we reach better candidates from them
-//    //if (HasOtherBaselineBetterCandidate(BaseRay, (*it)->point, ShortestAngle, RADIUS, LC) ) {
-//    if (0) {
-//      result = false;
-//      break;
-//    } else {
-//      // If there is no triangle, add it regularly.
-//      if (existentTrianglesCount == 0) {
-//        AddTesselationPoint((*it)->point, 0);
-//        AddTesselationPoint(BaseRay->endpoints[0]->node, 1);
-//        AddTesselationPoint(BaseRay->endpoints[1]->node, 2);
-//
-//        if (CheckLineCriteriaForDegeneratedTriangle((const BoundaryPointSet ** const )TPS)) {
-//          CandidateLine.point = (*it)->point;
-//          CandidateLine.OptCenter.CopyVector(&((*it)->OptCenter));
-//          CandidateLine.OtherOptCenter.CopyVector(&((*it)->OtherOptCenter));
-//          CandidateLine.ShortestAngle = ShortestAngle;
-//        } else {
-////          eLog() << Verbose(1) << "This triangle consisting of ";
-////          Log() << Verbose(0) << *(*it)->point << ", ";
-////          Log() << Verbose(0) << *BaseRay->endpoints[0]->node << " and ";
-////          Log() << Verbose(0) << *BaseRay->endpoints[1]->node << " ";
-////          Log() << Verbose(0) << "exists and is not added, as it 0x80000000006fc150(does not seem helpful!" << endl;
-//          result = false;
-//        }
-//      } else if ((existentTrianglesCount >= 1) && (existentTrianglesCount <= 3)) { // If there is a planar region within the structure, we need this triangle a second time.
-//          AddTesselationPoint((*it)->point, 0);
-//          AddTesselationPoint(BaseRay->endpoints[0]->node, 1);
-//          AddTesselationPoint(BaseRay->endpoints[1]->node, 2);
-//
-//          // We demand that at most one new degenerate line is created and that this line also already exists (which has to be the case due to existentTrianglesCount == 1)
-//          // i.e. at least one of the three lines must be present with TriangleCount <= 1
-//          if (CheckLineCriteriaForDegeneratedTriangle((const BoundaryPointSet ** const)TPS) || CandidateLine.BaseLine->skipped) {
-//            CandidateLine.point = (*it)->point;
-//            CandidateLine.OptCenter.CopyVector(&(*it)->OptCenter);
-//            CandidateLine.OtherOptCenter.CopyVector(&(*it)->OtherOptCenter);
-//            CandidateLine.ShortestAngle = ShortestAngle+2.*M_PI;
-//
-//          } else {
-////            eLog() << Verbose(1) << "This triangle consisting of " << *(*it)->point << ", " << *BaseRay->endpoints[0]->node << " and " << *BaseRay->endpoints[1]->node << " " << "exists and is not added, as it does not seem helpful!" << endl;
-//            result = false;
-//          }
-//      } else {
-////        Log() << Verbose(1) << "This triangle consisting of ";
-////        Log() << Verbose(0) << *(*it)->point << ", ";
-////        Log() << Verbose(0) << *BaseRay->endpoints[0]->node << " and ";
-////        Log() << Verbose(0) << *BaseRay->endpoints[1]->node << " ";
-////        Log() << Verbose(0) << "is invalid!" << endl;
-//        result = false;
-//      }
-//    }
-//
-//    // set baseline to new ray from ref point (here endpoints[0]->node) to current candidate (here (*it)->point))
-//    BaseRay = BLS[0];
-//    if ((BTS != NULL) && (BTS->NormalVector.NormSquared() < MYEPSILON)) {
-//      eLog() << Verbose(1) << "Triangle " << *BTS << " has zero normal vector!" << endl;
-//      exit(255);
-//    }
-//
-//  }
-//
-//  // remove all candidates from the list and then the list itself
-//  class CandidateForTesselation *remover = NULL;
-//  for (CandidateList::iterator it = OptCandidates->begin(); it != OptCandidates->end(); ++it) {
-//    remover = *it;
-//    delete(remover);
-//  }
-//  delete(OptCandidates);
-  return result;
-};
+}
+;
+
+/** Walks through Tesselation::OpenLines() and finds candidates for newly created ones.
+ * \param *&LCList atoms in LinkedCell list
+ * \param RADIUS radius of the virtual sphere
+ * \return true - for all open lines without candidates so far, a candidate has been found,
+ *         false - at least one open line without candidate still
+ */
+bool Tesselation::FindCandidatesforOpenLines(const double RADIUS, const LinkedCell *&LCList)
+{
+  bool TesselationFailFlag = true;
+  CandidateForTesselation *baseline = NULL;
+  BoundaryTriangleSet *T = NULL;
+
+  for (CandidateMap::iterator Runner = OpenLines.begin(); Runner != OpenLines.end(); Runner++) {
+    baseline = Runner->second;
+    if (baseline->pointlist.empty()) {
+      assert((baseline->BaseLine->triangles.size() == 1) && ("Open line without exactly one attached triangle"));
+      T = (((baseline->BaseLine->triangles.begin()))->second);
+      DoLog(1) && (Log() << Verbose(1) << "Finding best candidate for open line " << *baseline->BaseLine << " of triangle " << *T << endl);
+      TesselationFailFlag = TesselationFailFlag && FindNextSuitableTriangle(*baseline, *T, RADIUS, LCList); //the line is there, so there is a triangle, but only one.
+    }
+  }
+  return TesselationFailFlag;
+}
+;
 
 /** Adds the present line and candidate point from \a &CandidateLine to the Tesselation.
  * \param CandidateLine triangle to add
- * \NOTE we need the copy operator here as the original CandidateForTesselation is removed in AddTesselationLine()
- */
-void Tesselation::AddCandidateTriangle(CandidateForTesselation CandidateLine)
-{
-	Info FunctionInfo(__func__);
+ * \param RADIUS Radius of sphere
+ * \param *LC LinkedCell structure
+ * \NOTE we need the copy operator here as the original CandidateForTesselation is removed in
+ * AddTesselationLine() in AddCandidateTriangle()
+ */
+void Tesselation::AddCandidatePolygon(CandidateForTesselation CandidateLine, const double RADIUS, const LinkedCell *LC)
+{
+  Info FunctionInfo(__func__);
   Vector Center;
   TesselPoint * const TurningPoint = CandidateLine.BaseLine->endpoints[0]->node;
+  TesselPointList::iterator Runner;
+  TesselPointList::iterator Sprinter;
 
   // fill the set of neighbours
